"use strict";

var events = require("events");

var MyServer = {

    UDP: function (prefix) {

        const dgram = require("dgram");
        const srv = dgram.createSocket("udp4");

        var pfx = prefix;
        var open = false;
        var srvEvents = new events.EventEmitter();

        srv.on("error", (err) => {
            srvEvents.emit("server", err);
        });

        srv.on("close", () => {
            srvEvents.emit("server", "UDP Server Closed");
            open = false;
        });

        srv.on("listening", () => {
            srvEvents.emit("server", "UDP Server Open");
        });

        srv.on("message", (msg, udpinfo) => {
            let m = msg.toString("utf8");
            if (m.substring(0, pfx.length) == pfx) {
                srvEvents.emit("data", m.substring(pfx.length), udpinfo);
            }           
        });

        this.Open = function (iface, port) {
            if (!open) { srv.bind(port, iface); }
        }

        this.Close = function () {
            if (open) { srv.close(); }
        }

        this.Send = function (data,address,port){
            srv.send(new Buffer.from(prefix + data, "utf8"), port, address);
        }

        this.Events = srvEvents;

        this.IsOpen = open;

    }
}
module.exports = MyServer